org.jgroups.protocols

## Class PERF_TP

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.PERF_TP

    public class PERF_TP
    extends Protocol

Measures the time for a message to travel from the channel to the transport

Author:
  Bela Ban

### Field Summary

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`PERF_TP()`

### Method Summary

Methods
`boolean` `done()`
`java.lang.Object` `down(Event evt)` Caller by the layer above this layer.
`static PERF_TP` `getInstance()`
`long` `getNumMessages()`
`long` `getTotalTime()`
`void` `init()` Called after instance has been created (null constructor) and before protocol is started.
`void` `reset()`
`void` `setExpectedMessages(long m)`
`void` `start()` This method is called on a `Channel.connect(String)`.
`java.lang.String` `toString()`
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, resetStats, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, stop, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### PERF_TP

    public PERF_TP()

### Method Detail

#### getInstance

    public static PERF_TP getInstance()

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### done

    public boolean done()

#### getNumMessages

    public long getNumMessages()

#### setExpectedMessages

    public void setExpectedMessages(long m)

#### reset

    public void reset()

#### getTotalTime

    public long getTotalTime()

#### init

    public void init()
              throws java.lang.Exception

Description copied from class: `Protocol`
Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.

Overrides:
  `init` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

#### start

    public void start()
               throws java.lang.Exception

Description copied from class: `Protocol`
This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

Overrides:
  `start` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

#### down

    public java.lang.Object down(Event evt)

Caller by the layer above this layer. Usually we just put this Message into the send queue and let one or more worker threads handle it. A worker thread then removes the Message from the send queue, performs a conversion and adds the modified Message to the send queue of the layer below it, by calling Down).

Overrides:
  `down` in class `Protocol`

#### up

    public java.lang.Object up(Event evt)

Description copied from class: `Protocol`
An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

Overrides:
  `up` in class `Protocol`